function nu_break(varargin)
% code by jph

global nu

if isfield(nu,'device')&isfield(nu,'server')
  try
    % closing hardware
    nu.device.invoke('EnableData',false);
    nu.server.unregisterallevents;
    nu.server.release;
    % when loading data for post processing, fields device and server give errors  
    nu=rmfield(nu,{'device','server'}); % transient
  catch exception
    disp(exception)
  end
else
  disp('remark: device already stopped.')
end

if ~nargin
  disp('remark: device stopped.')
  disp('warning: data not saved yet, type <a href="">nu_save</a> to store data.')
end
