function val=prg_spell(varargin)
% code by Per-Anders Ekstroem, jph

import speller.*;

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=600;
    nurun(0:0.05:sec ,'prg_spell(''loop'')')
    nurun(sec        ,'prg_spell(''stop'')')
    prg=0;
    warning('OFF','MATLAB:warn_r14_stucture_assignment')
    prg.width=400;
    warning('ON','MATLAB:warn_r14_stucture_assignment')
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Pointer','crosshair',...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',... % only for simulink
                      'Color','k',...
                      'Colormap',[0 0 0;1 1 1],...
                      'Position',[1680 0 100 100]);
                      %'Position',[0 0 1680 1050]);
    prg.off=[0 0];
    prg.numel=1;    
    prg.mySpeller=speller.Speller(0,0,0,1680,1050); %(1600,100,880,650);
    prg.return=0;
  else
    prg.mySpeller.myJFrame.dispose();
    nu.run=0;
  end
else
  switch varargin{1}
  case 'loop'
    if prg.numel<nu.numel
      prg.numel=nu.numel;
      prg.toc=toc;
      val=[0.5 0.5];
      
      X=[nu.cell{nu.numel} ones(200,1)];
      sol=(median( X(end-60:end,user.eye.corrcoef{end}(:,1))*user.eye.corrcoef{end}(:,2:3) )+1 )/2;
      val=sol+prg.off;
      for c1=1:2
        if val(c1)<0
          prg.off(c1)=-sol(c1);
        end
        if 1<val(c1)
          prg.off(c1)=1-sol(c1);
        end
      end
        
      in3=min(max(0,val(1)),1);
      in4=1-min(max(0,val(2)),1);
      val=prg.mySpeller.mySpellerComponent.flush(10,40,in3,in4);
      if prg.return~=val
        soundsc(sin(1:100),5000)
        prg.return=val;
      end
    end    
  case 'stop'
    prg.mySpeller.myJFrame.dispose();
    close(prg.figure);
  end
end
