function [val,pospeak,negpeak]=peakdetect(val)
%,negpeak,latency

%input ======================================================================
fs=1000;
%Cut-off frequency===========================================================
fq=9:500; % these freq will be removed => 0...8 survive

pospeak=repmat(300,[1 size(val,2)]);
negpeak=pospeak;

fX=fft(val);
fX([1 1+fq end-fq+1],:)=0;   % 1 removes DC = 0 Hz
val=ifft(fX);
%sum(abs(imag(y)))  % check

dy=diff(val);
px=dy(2:end  ,:)<0 & 0<=dy(1:end-1,:);
nx=dy(1:end-1,:)<0 & 0<=dy(2:end  ,:);

for c1=1:size(val,2) %row-channel,column-time  
  ofs=600;
  fnd=find(px(ofs:end,c1))+ofs;
  if ~isempty(fnd)
    pospeak(c1)=fnd(1);
  end
  fnd=find(nx(ofs:end,c1))+ofs;
  if ~isempty(fnd)
    negpeak(c1)=fnd(1);
  end
end

