function val=prg_light(varargin)
%code by jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=nuget('varargin.struct','sec',120);
    %dlt=0.08;
    dlt=0.5;
    nurun(0:dlt:sec-dlt,'prg_light(1)')
    nurun(      sec    ,'prg_light(0)')
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',... %'Menubar','none',...  %'Pointer','custom',... 'PointerShapeCData',zeros(16)*NaN,...                      'DoubleBuffer','on',... %                      
                      'Color',[1 1 1],...     %                 'Colormap',[0 0 0;1 1 1],... % TODO see if makes difference !?                   
                      'Position',[1690 300 1250 680]); % [1 31 2560 968]
    num=numel(nu.light.legend);
    prg.light.axes=subplot(1+num,2,1);
    prg.light.plot=plot(0,0);
    title('photodiode (and microphone)')
    xlabel('[sec]')
    ylabel('V')
    hold on    
    prg.sound.plot=plot(0,0,'r:');
    prg.light.toc=plot(0,0,'r*');
    prg.light.now=plot(0,0,'ro');
    prg.light.toc_eval=plot(0,0,'go');
    prg.light.toc_pause=plot(0,0,'ko');
    prg.light.text=text(0,0,'','HorizontalAlignment','center');
    hold off
    prg.case=1;
    prg.nuscalp3.axes=subplot(1,2,2);
    %prg.nuscalp3.title=title('asdfg fdgs sdfg ');
    %get(prg.nuscalp3.title)
    prg.nuscalp3.hnd=nuscalp3(0,1,'alpha');
    view(-121,46)
    ind=[3 5];
    for c0=1:num
      prg.peaks.axes{c0}=subplot(num+1,2,ind(c0));
      for c1=1:3
        prg.peaks.plot{c0,c1}=plot(0,0,'Color',nuget('color',c1));
        hold on
        prg.peaks.max{c0,c1}=plot(0,0,'ro');
        prg.peaks.min{c0,c1}=plot(0,0,'go');
      end
      title(nu.light.legend{c0})
    end
    prg.linspace=linspace(-0.3,-0.3+1,1001); prg.linspace(end)=[];
    xlabel('[sec]')
  else
    nu.run=0;
  end
else
  val=varargin{1};
  switch val
  case 0
    close(prg.figure)
  otherwise
    if length(nu.light.events)<prg.case
      if length(nu.light.events) & nu.pause<0.095 % TODO last meaningful ...
        %chn=setdiff(1:41,nu.synchronize);
        %nuscalp3(rand(size(chn)),chn,prg.nuscalp3.hnd)      
      end
      return
    end
    ind=nu.light.events{prg.case}(1);
    tim=nu.events{ind}.toc_eval;
    rdy=200 + tim * 1000 + nu.light.shading < nu.numel * 200;
    if rdy
      [val,str]=nuget('triggered.flash',tim);
      if ~isempty(val)
        set(prg.light.plot     ,'XData',str.XData)
        set(prg.light.plot     ,'YData',str.YData)
        bnd_min=1;
        bnd_max=-1;
        if str.ZData(1)<1
          bnd_min=min(str.ZData);
          bnd_max=max(str.ZData);
          set(prg.sound.plot   ,'XData',str.XData)
          set(prg.sound.plot   ,'YData',str.ZData)
        else
          set(prg.sound.plot   ,'XData',str.XData(1))
          set(prg.sound.plot   ,'YData',str.YData(1))        
        end
        set(prg.light.toc      ,'XData',str.toc)
        set(prg.light.toc      ,'YData',str.mean)
        set(prg.light.now      ,'XData',nu.events{ind}.now)
        set(prg.light.now      ,'YData',str.mean)
        set(prg.light.toc_eval ,'XData',tim)
        set(prg.light.toc_eval ,'YData',str.mean)
        set(prg.light.toc_pause,'XData',nu.events{ind}.toc_pause)
        set(prg.light.toc_pause,'YData',str.mean)
        set(prg.light.text     ,'Position',[0.5*(str.toc+nu.events{ind}.toc_pause) str.mean 0])
        set(prg.light.text     ,'String',num2str(str.toc-nu.events{ind}.toc_pause))
        %axis(prg.light.axes,[min(str.XData)-0.01 max(str.XData) min(str.YData) max(str.YData)]) % update the viewport        
        axis(prg.light.axes,[str.XData(1)-0.01 str.XData(end) min(min(str.YData),bnd_min) max(max(str.YData),bnd_max)]) % update the viewport        
        [blk,tim]=nuget('grab.block',val+[-0.3 0.699],1:40);
        chn=setdiff(find(all(blk<1)),nu.light.channel);
        rdy=tim(end) < (nu.numel-1) * 0.2;
        if rdy
          % do processing here
          chn=setdiff(1:41,nu.light.channel); % TEMPORARY DEVEL SOL
          blk=rand(1000,length(chn));       % TEMPORARY DEVEL SOL          
          [y,pospeak,negpeak]=peakdetect(blk);          
          c0=nu.light.events{prg.case}(2);          
          for c1=1:3
            set(prg.peaks.plot{c0,c1},'XData',prg.linspace);
            set(prg.peaks.plot{c0,c1},'YData',y(:,c1)');
            idx=pospeak(c1);
            set(prg.peaks.max{c0,c1},'XData',prg.linspace(idx));
            set(prg.peaks.max{c0,c1},'YData',y(idx,c1));
            idx=negpeak(c1);
            set(prg.peaks.min{c0,c1},'XData',prg.linspace(idx));
            set(prg.peaks.min{c0,c1},'YData',y(idx,c1));
          end          
          %nuscalp3(blk(pospeak(find(chn==20)),:),chn,prg.nuscalp3.hnd)          
        else
          disp('blocked')
          rdy=0;
        end
      end
      prg.case=prg.case+rdy;
    end
  end
end
