function val=prg_blink(varargin)

global nu
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin

    sec=80; % total duration
    
    tim=0;
    while tim+1<sec
      left=0.5<rand;
      right=0.5<rand;
      if ~left|~right
        if rand<0.5
          left=1;
        else
          right=1;
        end
      end
      nurun(tim    ,sprintf('prg_blinklr(%i,%i)',left,right))
      nurun(tim+0.3,'prg_blinklr(0,0)')
      tim=tim+1+2*rand;
    end
    nurun(sec,'prg_blinklr(0)')

    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Pointer','custom',...
                      'PointerShapeCData',zeros(16)*NaN,...
                      'Color',[0.3 0.3 0.3],...
                      'Colormap',[0 0 0;1 1 1],... % TODO see if makes difference !?                   
                      'Position',[1 1 1680 1024]); % [1 31 2560 968]
    prg.axes=subplot('Position',[0 0 1 1]);  
    prg.plot=plot(0,0,'b.');
    axis([-1 1 -1 1])
    axis off
    hold on
    
    prg.left=plot(-0.5,0,'r.');
    set(prg.left,'MarkerSize',1000)
    set(prg.left,'Visible','off')
    
    prg.right=plot( 0.5,0,'r.');
    set(prg.right,'MarkerSize',1000)
    set(prg.right,'Visible','off')
    
    prg.rectangle.hnd=rectangle('Position',[-1 -1 .06 .1],'FaceColor','k','EraseMode','background','Visible','on');
    prg.rectangle.cnt=0;

  else
    nu.run=0;
  end
else
  switch nargin
  case 1
    close(prg.figure)
  case 2
    left=varargin{1};
    right=varargin{2};
    if left
      set(prg.left,'Visible','on')  
    else
      set(prg.left,'Visible','off')
    end  
    if right
      set(prg.right,'Visible','on')
    else
      set(prg.right,'Visible','off')
    end      
    ron=1+(left | right);
    set(prg.rectangle.hnd,'FaceColor',repmat(ron-1,[1 3]))

    val=[left right];
  end
end
